/**
	Definitions for one cylinder program
	Fraga Nov 5, 2001
**/
#ifndef CYLINDER_H
#define CYLINDER_H

#include <qwidget.h>
#include <qgl.h>
#include <qtimer.h>

class Cone : public QGLWidget
{
	#define SIZECYL 12
	#define SIZECYL_V SIZECYL + 1 
	#define SIZECYL_N 2*SIZECYL + 1

	Q_OBJECT  // must include this if you use Qt signals/slots
public:
	Cone( QWidget *parent=0, const char *name=0 );
	QSizePolicy sizePolicy() const;
	void getPosition ( int *x, int *y ) { *x = xmouse; *y = ymouse; }
	void getSize ( int *w, int *h ) { 
		*w = windowWidth; *h = windowHeight; 
	}

public slots:
	void timerDone( void );
	void initscreen( void ) { 
		timer->start(500);
	}
	void stop( void ) {
		timer->stop( );
 	} 
	void shade_model( int n ) {
		if ( n != shade ) {
			shade = n;
			updateGL( );
		}
	}

signals:
	void changePos( ); // called when mouse is moved
	void changeSize( ); // called when windows is resized
 
protected:
	void initializeGL( void );
	void resizeGL( int w, int h );
	void paintGL( void );
	void mouseMoveEvent( QMouseEvent * );
	void InitMaterials( void );
	void keyPressEvent ( QKeyEvent * e );
	// void mousePressEvent( QMouseEvent * );
 
 
private:
	void getcone ( float cx, float cy, float cz, float high, float radius,
	                   float p[][3], float normal[][3], int n );
	void show_cone ( float p[][3], float normals[][3], int n );

	QTimer *timer;

	int windowWidth, windowHeight;   // canvas width and height

	float cyl1[SIZECYL_V][3]; // Vertices data for one cylinder
	float nor1[SIZECYL_N][3]; // Normal to each vertice 

	float yrot, xrot;  // Encene rotation

	int wholight; 
	float scale;
	float angle;
	int signo, shade;
	int xmouse, ymouse;  // Mouse pointer coordinates
};


#endif // CYLINDER_H
